<template>
  <el-container class="pokemonDetail" v-loading="isLoading">
    <el-main v-if="pokemon">
      <el-row>
        <img class="pokemonImage" :src="pokemonImageUrl()">
      </el-row>
      <el-row>
        <h1 class="pokemonName">{{ pokemon.name | capitalize }}</h1>
        <div class="badges">
          <el-badge class="mark" :value="pokemon.base_experience + ' EXP'"/>
        </div>
      </el-row>
      <hr>
      <el-row class="basic-stats" type="flex" justify="center">
        <el-col :span="3" v-for="stat in stats" :key="stat.name">
          <div class="stat">
            <img :src="stat.iconUrl">
            <p>{{ stat.baseValue }}</p>
          </div>
        </el-col>
      </el-row>
      <hr>
      <el-row class="abilities" v-if="abilities">
        <el-col :span="18" :offset="3">
          <h2>Abilities</h2>
          <el-row :gutter="40" type="flex" justify="center">
            <el-col :span="6" v-for="ability in abilities" :key="ability.name">
              <div class="ability">
                <h5 class="ability-name">{{ ability.name | capitalize }}</h5>
                <p class="ability-effect">{{ ability.effect }}</p>
              </div>
            </el-col>
          </el-row>
        </el-col>
      </el-row>
    </el-main>
  </el-container>
</template>

<script>
import { Api } from "@/common/api";

export default {
  name: 'pokemonDetail',
  data() {
    return {
      pokemon: null,
      abilities: null,
      statsImages: {
        'hp': 'https://png.icons8.com/color/96/3254E0/heart-pokemon.png',
        'attack': 'https://png.icons8.com/color/96/3254E0/sword.png',
        'defense': 'https://png.icons8.com/color/96/3254E0/shield.png',
        'special-defense': 'https://png.icons8.com/color/96/3254E0/shield.png',
        'special-attack': 'https://png.icons8.com/color/96/3254E0/sword.png',
        'speed': 'https://png.icons8.com/color/96/3254E0/shoes.png'
      },
      isLoading: false
    }
  },
  methods: {
    loadPokemon(name) {
      this.isLoading = true;

      return Api.get(`pokemon/${name}/`).then(({data}) => {
        this.pokemon = data;

        let abilities = this.pokemon.abilities.map( a =>  a.ability.name );

        Api.getMany('ability', abilities).then( response => {
          this.isLoading = false;

          this.abilities = response.map( r => {
            return {
              name: r.data.name,
              effect: r.data.effect_entries.find( e => e.language.name === 'en').short_effect
            }
          });
        });
      }).catch( () => {
        this.$router.push({ name: 'pokemons' });
      });
    },
    pokemonImageUrl() {
      return this.pokemon ? this.pokemon.sprites.front_default : null;
    }
  },
  computed: {
    stats() {
      return this.pokemon.stats.map( s => {
        return {
          name: s.stat.name,
          baseValue: s.base_stat,
          iconUrl: this.statsImages[s.stat.name]
        }
      }).reverse();
    }
  },
  mounted() {
    this.loadPokemon(this.$router.currentRoute.params.name);
  },
  beforeRouteUpdate (to, from, next) {
    this.loadPokemon(to.params.name);
    next();
  }
}

</script>

<style lang="scss">

hr {
  width: 50%;
  margin: auto;
}

.badges {
  margin-top: 5px;
  margin-bottom: 20px;
}

.pokemonDetail {
  height: 100%;
  background: #fdfdfd;
}

.pokemonImage {
  height: 150px;
  width: 150px;
  margin: 0;
}

.pokemonName {
  margin-top: -10px;
  margin-bottom: 0;
}

.basic-stats {
  .el-col {
    margin: 0;
  }

  .stat {
    display: flex;
    align-items: center;
    justify-content: center;

    img {
      height: 40px;
      width: 40px;
    }

    p {
      font-size: 1.3em;
      font-weight: 300;
      margin-left: 12px;
      padding: 0;
    }
  }
}

.abilities {
  margin-top: 30px;

  h2 {
    margin-top: 0;
    margin-bottom: 30px;
  }

  .ability {
    text-align: left;

    .ability-name {
      font-size: 1.2em;
      margin-top: 0;
      margin-bottom: 10px;
    }
    .ability-effect {
      margin: 0;
    }
  }
}

</style>